Thumbnail support for PDF attachments may not be detected

2020-04-09 12:34 - VVD VVD

Status: Closed Start date:  

Priority: Normal Due date:  

Assignee: Go MAEDA % Done: 0%

Category: Attachments Estimated time: 0.00 hour

Target version: 4.1.2   

Resolution: Fixed Affected version: 4.1.1

Description

In lib/redmine/thumbnail.rb:

        begin

          `gs -version`

          @gs_available = $?.success?

        rescue

          @gs_available = false

        end

Can't detect ImageMagick PDF support.    

But if I add full path to gs:

        begin

          `/usr/local/bin/gs -version`

          @gs_available = $?.success?

        rescue

          @gs_available = false

        end

then it detects ImageMagick PDF suport.    

Patch for 4.1.1 to fix it:

--- config/configuration.yml.example.orig

+++ config/configuration.yml.example

@@ -179,6 +179,10 @@

   # the ImageMagick's `convert` binary. Used to generate attachment thumbnails.

   #imagemagick_convert_command:

+  # Absolute path (e.g. /usr/bin/gs, c:/ghostscript/gs.exe) to

+  # the `gs` binary. Used to generate attachment thumbnails of PDF files.

+  #gs_command:

+

   # Configuration of MiniMagick font.

   #

   # Redmine uses MiniMagick in order to export a gantt chart to a PNG image.

--- lib/redmine/thumbnail.rb.orig

+++ lib/redmine/thumbnail.rb

@@ -25,6 +25,7 @@

     extend Redmine::Utils::Shell

     CONVERT_BIN = (Redmine::Configuration['imagemagick_convert_command'] || 'convert').freeze

+    GS_BIN = (Redmine::Configuration['gs_command'] || 'gs').freeze

     ALLOWED_TYPES = %w(image/bmp image/gif image/jpeg image/png application/pdf)

     # Generates a thumbnail for the source image to target
@@ -79,12 +80,13 @@

         @gs_available = false

       else

         begin

-          `gs -version`

+          `#{shell_quote GS_BIN} -version`

           @gs_available = $?.success?

         rescue

           @gs_available = false

         end

       end

+      logger.warn("gs binary (#{GS_BIN}) not available") unless @gs_available

       @gs_available

     end

Related issues:

Related to Redmine - Feature #22481: Show thumbnails for PDF attachments Closed

Related to Redmine - Feature #32898: PDF thumbnails support on Windows Closed

Associated revisions

Revision 19712 - 2020-04-20 16:15 - Go MAEDA

Fix that thumbnail support for PDF attachments may not be detected (#33283).

Patch by VVD VVD.

Revision 19713 - 2020-04-20 16:16 - Go MAEDA

Merged r19712 from trunk to 4.1-stable (#33283).

History

#1 - 2020-04-12 18:37 - Marius BĂLTEANU

- Target version set to Candidate for next major release

#2 - 2020-04-19 15:44 - VVD VVD

Why "Candidate for next major release"?

It's so small and obvious fix!

#3 - 2020-04-19 20:04 - Marius BĂLTEANU

- File 33283.patch added

- Target version changed from Candidate for next major release to 4.1.2

The patch looks good to me and the tests pass.

VVD VVD wrote:

Why "Candidate for next major release"?

It's so small and obvious fix!

 It was just an initial target version, but I don't see a real problem to deliver this fix in 4.1.2. I've created a patch file from the diff.

#4 - 2020-04-19 23:58 - VVD VVD

Thanks.

Just checked - for create attachment thumbnails of PDF files used convert. And gs binary isn't necessary.

#5 - 2020-04-20 15:14 - Go MAEDA

- Related to Feature #22481: Show thumbnails for PDF attachments added

#6 - 2020-04-20 16:17 - Go MAEDA

- Subject changed from Can't detect support of thumbnails for PDF attachments to Thumbnail support for PDF attachments may not be detected

- Status changed from New to Closed

- Assignee set to Go MAEDA
- Resolution set to Fixed

Committed the patch. Thank you.

#7 - 2020-04-20 17:34 - VVD VVD

Thanks!

#8 - 2020-06-21 21:25 - David Gessel

Thanks for this patch - just tested this patch on a FreeBSD 11.3 install where the ports version is currently redmine4-4.1.1_2 and the patch and

configuration.yml modification resulted in pdf support finally being available.  :-)

- ghostscript9-agpl-base-9.52_5

 - ImageMagick7-nox11-7.0.10.6

 - rubygem-mini_magick-4.10.1

 Success.  Thanks.

#9 - 2020-06-26 03:54 - Go MAEDA

- Related to Feature #32898: PDF thumbnails support on Windows added

Files

33283.patch 1.25 KB 2020-04-19 Marius BĂLTEANU
